<?php

!defined('XIUNO_ROOT') && exit;

class control extends _control {

	function __construct() {
		parent::__construct();
	}

	// ѫб
	public function index() {
		$medallist = $this->medalmodel->get_medals();
		if(!empty($medallist)) {
			foreach ($medallist as &$v) {
				if($v['expiration'] == 0) {
					$v['expiration'] = '';
				} else {
					$v['expiration'] = $this->date($v['expiration'], 'Ymd');
				}
			}
		}

		$this->view->assign('medallist', $medallist);
		$this->view->display('admin_medal');
	}
	
	public function userls() {
		// ûѫб
		$uids = $this->medalmodel->get_has_medal_users();
		$usermedals = array();
		if(!empty($uids)) {
			foreach($uids as $uid) {
				$temp = array();
				$temp['uid'] = $uid['uid'];
				$temp['username'] = $this->usermodel->get_username_by_uid($uid['uid']);

				$usermedal = $this->medalmodel->get_usermedal_by_uid($uid['uid']);
				foreach($usermedal as $key=>$value) {
					$usermedal[$key]['medal'] = $this->medalmodel->get_medal_by_medalid($value['medalid']);
				}
				$temp['medals'] = $usermedal;
				array_push($usermedals, $temp);
			}
		}
		$this->view->assign('usermedals', $usermedals);
		$this->view->display('admin_medal');
	}

	public function add() {
		if(!$this->submitcheck()) {
			$this->view->display('admin_medal');
		} else {
			$medalname  = getgpc('medalname', 'P');
			$medalfile  = $_FILES['medalfile'];
			$expiration = getgpc('expiration', 'P');
			if(!$medalname) {
				$this->message('дѫ', 'BACK');
			}
			if(!$medalfile) {
				$this->message('ѡϴͼƬ', 'BACK');
			}
			// ݲmedalid
			$medalid = $this->medalmodel->insert_medal($medalname, $this->strtotime($expiration));
			// ϴͼƬ
			if(!empty($medalfile)) {
				$uploadavatar = $medalfile['tmp_name'];
				require_once XIUNO_ROOT.'lib/upload.class.php';
				$imagesrc = XIUNO_ATTACH_DIR."medal/medal_$medalid.gif";
				$upload = new Upload();
				$upload->set_allowext($this->setting['allowext']);
				$upload->thumb(20, 35, $uploadavatar, $imagesrc, 'gif');
			}
			$this->cachemodel->update('medals');
			$this->message('ϴѫ³ɹ', XIUNO_HOST_ADMIN.'medal-index.htm');
		}
	}

	public function delete() {
		$medalid = getgpc(2);
		$this->medalmodel->delete_medal($medalid);
		@unlink( XIUNO_ATTACH_DIR."medal/medal_$medalid.gif");
		$this->cachemodel->update('medals');
		$this->message('ѫɾɹ', XIUNO_HOST_ADMIN.'medal-index.htm');
	}

	public function edit() {
		$medalid    = getgpc(2);
		
		if(!$this->submitcheck()) {
			$medal = $this->medalmodel->get_medal_by_medalid($medalid);
			$this->view->assign('medal', $medal);
			$this->view->display('admin_medal');
		} else {
			$medalname  = getgpc('medalname', 'P');
			$medalfile  = $_FILES['medalfile'];
			$expiration = $this->strtotime(getgpc('expiration', 'P'));
			if(!$medalname) {
				$this->message('дѫ', 'BACK');
			}
			$this->medalmodel->update_medal($medalid, array('medalname'=>$medalname, 'expiration'=>$expiration));
			// ϴͼƬ
			if(!empty($medalfile['tmp_name'])) {
				$uploadavatar = $medalfile['tmp_name'];
				require_once XIUNO_ROOT.'lib/upload.class.php';
				$imagesrc =  XIUNO_ATTACH_DIR."medal/medal_$medalid.gif";
				$upload = new Upload();
				$upload->set_allowext($this->setting['allowext']);
				$upload->thumb(20, 35, $uploadavatar, $imagesrc, 'gif');
			}
			$this->cachemodel->update('medals');
			$this->message('޸ѫ³ɹ', XIUNO_HOST_ADMIN.'medal-index.htm');
		}
	}

	// ajax
	public function give() {
		$medalid  = getgpc(2);
		if(!$this->submitcheck()) {
			//$hasmedal = $this->medalmodel->get_medals_num_by_uid($uid);
			$this->view->assign('medalid', $medalid);
			$this->view->display('admin_medal_give');
		} else {
			$usernames = getgpc('usernames', 'P');
			$usernames = str_replace('', ',', $usernames);
			$usernames = str_replace(',', ' ', $usernames);
			$usernames = explode(' ', $usernames);
			foreach($usernames as $username) {
				$uid = $this->usermodel->get_uid_by_username($username);
				if(empty($uid)) {
					continue;
					//$this->message('û', '', array('error'=>10001));
				} else {
					if($this->medalmodel->is_usermedal_exists($uid, $medalid)) {
						continue;
						//$this->message('Ѿûѫˡ', '', array('error'=>10002));
					} else {
						$this->medalmodel->insert_usermedal($uid, $medalid);
					}
				}
			}
			$this->message('');
		}
	}

	// ajax
	public function rollback() {
		$id    = getgpc(2);
		$medal = $this->medalmodel->get_usermedal_by_id($id);
		$uid   = $medal['uid'];
		$this->medalmodel->delete_usermedal($id, $uid);
		$medalnum = $this->medalmodel->get_medals_num_by_uid($uid);
		if($medalnum > 0) {
			$int = $this->medalmodel->format_medalint_by_uid($uid);
			$this->usermodel->update_user($uid, "medallist='$int'");
		} else {
			$this->usermodel->update_user($uid, "medallist=''");
		}
		$this->message('ճɹ', XIUNO_HOST_ADMIN.'medal-index.htm');
	}
}
?>