<?php

!defined('XIUNO_ROOT') && exit;

class control extends _control {

	function __construct() {
		parent::__construct();
		$this->set_navcheck('www');
	}

	public function index() {
		//$this->db->memcache_flush();

		require_once(XIUNO_ROOT.'lib/sphinxapi.class.php');
		$forums = $this->cache('forums');

		// 
		$bbsdata = $this->cache('bbs');
		$forumgroups = $bbs['forumgroups'];
		$this->view->assign('forumgroups', $bbsdata['forumgroups']);

		$host = XIUNO_SPHINX_HOST;
		$port = XIUNO_SPHINX_PORT;//3312

		$keyword = getgpc('keyword');
		$fid = getgpc('fid');
		$day = getgpc('day');
		if($day) {
			$daterange = $day * DAY;
		} else {
			$daterange = 0;
		}

		$keyword = trim(str_replace('', ' ', $keyword));
		$multipage = '';

		if($keyword) {
			$srchby = getgpc('srchby');
			$srchby = $srchby && in_array($srchby, array('subject', 'message', 'username')) ? $srchby : 'subject';
			$srchbychecked = array($srchby=>'checked="checked"');

			$page = max(1, getgpc('page'));
			$tpp = 15;
			$start = ($page - 1) * $tpp;
			$end = $start + $tpp;
			$mode = SPH_MATCH_ALL;
			$ranker = SPH_RANK_PROXIMITY_BM25;

			$cl = new SphinxClient();
			$cl->SetServer($host, $port);
			if($srchby == 'username') {
				$cl->SetFieldWeights(array('subject'=>1, 'message'=>1, 'username'=>100000));
			}
			$cl->SetMatchMode($mode);
			$cl->SetLimits($start, $tpp);
			//趨order byݣһ򷽷ֵ
			// SPH_SORT_RELEVANCE,SPH_SORT_ATTR_DESC,SPH_SORT_ATTR_ASC,SPH_SORT_TIME_SEGMENTS,SPH_SORT_EXTENDED
			//$sortbyֵ"HITS desc"

			$indexname = $srchby == 'subject' || $srchby == 'username' ? 'xiuno_subject' : 'xiuno_message';

			//  fid
			if($fid) {
				$sonsfid = $this->get_sons_fid($fid, $forums);
				$cl->SetFilter ('fid', $sonsfid, false );
			}

			//  fid ȥڲ
			$cl->SetFilter ('fid', array('40', '65'), true );

			// һڵ
			if($daterange) {
				$cl->SetFilterRange ('dateline', $this->time - $daterange, $this->time);
			}
			if($srchby != 'username') {
				$cl->SetSortMode(SPH_SORT_EXTENDED, 'tid2 desc');
			}

			$res = $cl->Query($keyword, $indexname);
			$threadlist = array();

			// ɾƶӹ˵
			$s = trim(file_get_contents(XIUNO_TMP_DIR.'deleted_tid.txt'));

			foreach($res['matches'] as &$v) {
				$tid = $v['attrs']['tid2'];
				$thread = $this->db->fetch_first("/*cachelife=3600&mckey=bbs_thread_$tid*/ SELECT * FROM bbs_thread WHERE tid='$tid'");
				$post = $this->db->fetch_first("/*cachelife=3600&mckey=bbs_post_$thread[firstpid]*/ SELECT * FROM bbs_post WHERE pid='$thread[firstpid]'");
				if(empty($thread)) {
					continue;
				}
				if(!empty($s)) {
					if(strpos("\t".$s."\t", $tid) !== FALSE) {
						continue;
					}
				}
				//$v['post'] = array_merge($arr1, $arr2);
				$thread['subject'] = trim($this->xiuno_substr(strip_tags($thread['subject']), 64));
				$post['message'] = $this->xiuno_substr(strip_tags($post['message']), 256);
				if(empty($thread['subject'])) {
					$thread['subject'] = $this->xiuno_substr($post['message'], 64);
				}
				$thread['messagelen'] = strlen($post['message']);
				$thread['dateline'] = $this->date($thread['dateline']);
				$thread['forumname'] = strip_tags($forums[$thread['fid']]['name']);
				$this->highlight($thread['subject'], $keyword);
				$this->highlight($post['message'], $keyword);
				$this->highlight($post['forumname'], $keyword);

				$threadlist[$tid] = array_merge($post, $thread);
			}
			$multipage = $this->page($res['total'], $tpp, $page, XIUNO_HOST_SO."index.htm?srchby=$srchby&fid=$fid&day=$day&keyword=".urlencode($keyword), 0);
		}
		foreach($forums as &$forum) {
			$forum['name'] = strip_tags($forum['name']);
		}

		$this->view->assign_value('start', $start);
		$this->view->assign_value('end', $end);
		$this->view->assign_value('keyword', $keyword);
		$this->view->assign_value('keywordurl', urlencode($keyword));
		$this->view->assign('srchbychecked', $srchbychecked);
		$this->view->assign('srchby', $srchby);
		$this->view->assign('threadlist', $threadlist);
		$this->view->assign('res', $res);
		$this->view->assign('day', $day);
		$this->view->assign('fid', $fid);
		$this->view->assign('forums', $forums);
		$this->view->assign('multipage', $multipage);
		$this->view->display('so');
	}

	public function highlight(&$string, $keywords){
		foreach(explode(' ', $keywords) as $keyword) {
			$string = str_replace($keyword, "<span class=\"highlight\">$keyword</span>", $string);
		}
	}

	/*public function get_sons_fid($fid, $forums) {
	$return = array();
	foreach($forums as $forum) {
	if($forum['fup'] == $fid) {
	$return[] = $forum['fid'];
	foreach($forums as $forum2) {
	if($forum2['fup'] == $forum['fid']) {
	$return[] = $forum2['fid'];
	}
	}
	}
	}
	return $return;
	}*/

	public function get_sons_fid($fid, $forums) {
		$return = array();
		foreach($forums as $forum) {
			if(isset($forum['fup']) && $forum['fup'] == $fid) {
				$return[] = $forum['fid'];
			}
			if(isset($forums[$forum['fup']]['fup']) && $forums[$forum['fup']]['fup'] == $fid) {
				$return[] = $forum['fid'];
			}
		}
		return $return;
	}
}