<?php

define('model/creditmodel.php', 1);

class creditmodel {

	private $db;
	private $base;
	private $creditpolicy = array();
	private $creditsformula = '';

	function __construct(&$base) {
		$this->base = $base;
		$this->db = $base->db;
	}

	/*
	 * @param $uid int
	 * @param $action char : Ŀ ǰ׺'_'ʾ  'post','thread','digest', '_post', '_thread'
	 * @param $fid int
	 */
	public function update_credit_by_policy($uid, $action='', $fid=0) {
		if(empty($action)  || empty($uid)) {
			return false;
		}
		$fid = $fid ? $fid : 0;
		if(!$this->checklowerlimit($uid, $action, $fid)) {
			return false;
		}
		$creditpolicy = $this->get_policy($fid);
		if($action{0} == '_') {
			$action = substr($action, 1);
			$policy = array();
			foreach($creditpolicy[$action] as $k=>$v) {
				$policy[$k] = -$v;
			}
			$this->update_credit($uid, $policy);
			return true;
		}
		$this->update_credit($uid, $creditpolicy[$action]);
		return true;
	}

	// $uid int
	// $actions array('fid'=>array('action1'=>num1, 'action2'=>num2))
	public function update_credit_by_actions($uid, $actions) {
		$policy = array(1=>0, 2=>0, 3=>0, 4=>0);
		foreach($actions as $fid=>$actionlist) {
			$creditpolicy = $this->get_policy($fid);
			foreach($actionlist as $action=>$num) {
				if($action{0} == '_') {
					$action = substr($action, 1);
					foreach($creditpolicy[$action] as $k=>$v) {
						if($k != 'name') {
							$policy[$k] += -$v * $num;
						}
					}
				} else {
					foreach($creditpolicy[$action] as $k=>$v) {
						if($k != 'name') {
							$policy[$k] += $v * $num;
						}
					}
				}
			}
		}
		$this->update_credit($uid, $policy);
		return true;
	}

	public function update_credit($uid, $credit, $username = '') {
		$policy1 = getvalue($credit[1]);
		$policy2 = getvalue($credit[2]);
		$policy3 = getvalue($credit[3]);
		$policy4 = getvalue($credit[4]);
		if(empty($this->creditsformula)) {
			$this->get_policy();
		}
		$user = $this->base->usermodel->get_user_by_uid($uid, '*');

		$threads	= $user['threads'];
		$posts		= $user['posts'];
		$digest		= $user['digest'];
		$extcredits1	= $user['extcredits1'] + $policy1;
		$extcredits2	= $user['extcredits2'] + $policy2;
		$extcredits3	= $user['extcredits3'] + $policy3;
		$extcredits4	= $user['extcredits4'] + $policy4;
		$onlinetime	= $user['onlinetime'];
		
		$this->creditsformula = str_replace(array('', '', '', '', '', '', '', ''), array('{', '}', '+', '-', '*', '(', ')', ' '), $this->creditsformula);
		$creditsformula = str_replace(array('{}', '{ظ}', '{}', '{1}', '{2}', '{3}', '{4}', '{ʱ}'), array('$threads', '$posts', '$digest', '$extcredits1', '$extcredits2', '$extcredits3', '$extcredits4', '$onlinetime'), $this->creditsformula);

		//$credits = $creditsformula;
		eval('$credits = '.$creditsformula.';');
		$credits = intval($credits);
		$this->base->usermodel->update_user($uid, "
			credits		= '$credits',
			extcredits1	= extcredits1+'$policy1',
			extcredits2	= extcredits2+'$policy2',
			extcredits3	= extcredits3+'$policy3',
			extcredits4	= extcredits4+'$policy4'
		");
		!$username && $username = $this->base->usermodel->get_username_by_uid($uid);
		return true;
	}

	public function checklowerlimit($uid, $action = '', $fid = 0) {
		if(empty($action) || empty($uid)) {
			return false;
		}
		$creditpolicy = $this->get_policy($fid);
		$credit = $this->get_credit($uid);
		$policy = $creditpolicy[$action];
		foreach($policy as $k=>$v) {
			$ext = 'extcredits'.$k;
			if(isset($credit[$ext]) && $credit[$ext] + $v <0) {
				return false;
			}
		}
		return true;
	}

	public function get_credit($uid) {
		if(isset($this->user['credits'])) {
			return $this->user;
		} else {
			//return $this->db->fetch_first("SELECT credits,extcredits1,extcredits2,extcredits3,extcredits4 FROM www_user WHERE uid='$uid'");
			return $this->base->usermodel->get_user_by_uid($uid, "credits,extcredits1,extcredits2,extcredits3,extcredits4");
		}
	}

	public function get_extcredit_name($i) {
		$this->get_policy();
		return $this->extcredits[$i]['title'];
	}

	private function get_policy($fid=0) {
		$fid = $fid ? $fid : 0;
		if(!empty($this->creditpolicy[$fid])) {
			return $this->creditpolicy[$fid];
		}
		if(empty($this->creditpolicy[0])) {
			$this->creditpolicy[0] = $this->base->setting['creditpolicy'];
			$this->creditsformula = $this->base->setting['creditsformula'];
			$this->extcredits = $this->base->setting['extcredits'];
		}
		$creditpolicy = $this->creditpolicy[0];
		if($fid) {
			$forum = $this->base->cache('forum', $fid);
			foreach ($forum['creditpolicy'] as $k=>$v) {
				$k && $creditpolicy[$k] = $v;
			}
			$this->creditpolicy[$fid] = $creditpolicy;
		}
		return $creditpolicy;
	}
}
?>