<?php

define('model/forummodel.php', 1);

class forummodel {

	private $db;
	private $base;

	function __construct(&$base) {
		$this->base = $base;
		$this->db = $base->db;
	}

	public function get_forum_by_fid($fid) {
		return $this->db->fetch_first("SELECT * FROM bbs_forum WHERE fid='$fid'");
	}

	public function get_moderator_by_fid($fid) {
		$moderators = $this->db->fetch_all("SELECT username FROM bbs_moderator WHERE fid='$fid'");
		$str = '';
		foreach($moderators as $moderator) {
			$str .= $moderator['username'].',';
		}
		return substr($str, 0, -1);
	}

	public function get_forum_tree() {
		$forumdata = $this->base->cache('forumsdata');
		$groups = $forumdata['grouplist'];
		$forums = $forumdata['forumlist'];
		$subs = $forumdata['sublist'];
		$s = '<ul>';
		foreach((array)$groups as $group) {
			$s .= "<li><a href=\"".XIUNO_HOST_BBS."forum-index-{$group['fid']}.htm\"><b>$group[name]</b></a> <input type=\"text\" size=\"4\" value=\"$group[displayorder]\" name=\"displayorder[$group[fid]]\"> <a href=\"".XIUNO_HOST_ADMIN."forum-edit-$group[fid].htm\">[༭]</a> <a href=\"".XIUNO_HOST_ADMIN."forum-delete-$group[fid].htm\">[ɾ]</a> <a href=\"".XIUNO_HOST_ADMIN."forum-moderator-$group[fid].htm\" onclick=\"ajaxmenu(this.href, 1)\">[ð]</a>".($group['status'] ? '<span class="alert">[]</span>' : '');
			$s2 = '';
			if(!empty($forums[$group['fid']])) {
				foreach((array)$forums[$group['fid']] as $forum) {
					$s2 .= "<li><a href=\"".XIUNO_HOST_BBS."forum-index-{$forum['fid']}.htm\"><b>$forum[name]</b></a> <input type=\"text\" size=\"4\" value=\"$forum[displayorder]\" name=\"displayorder[$forum[fid]]\"> <a href=\"".XIUNO_HOST_ADMIN."forum-edit-$forum[fid].htm\">[༭]</a> <a href=\"".XIUNO_HOST_ADMIN."forum-delete-$forum[fid].htm\">[ɾ]</a> <a href=\"".XIUNO_HOST_ADMIN."forum-moderator-$forum[fid].htm\" onclick=\"ajaxmenu(this.href, 1)\">[ð]</a>".($forum['status'] ? '<span class="alert">[]</span>' : '');
					$s3 = '';
					if(!empty($subs[$forum['fid']])) {
						foreach((array)$subs[$forum['fid']] as $sub) {
							$s3 .= "<li><a href=\"".XIUNO_HOST_BBS."forum-index-{$sub['fid']}.htm\"><b>$sub[name]</b></a> <input type=\"text\" size=\"4\" value=\"$sub[displayorder]\" name=\"displayorder[$sub[fid]]\"> <a href=\"".XIUNO_HOST_ADMIN."forum-edit-$sub[fid].htm\">[༭]</a> <a href=\"".XIUNO_HOST_ADMIN."forum-delete-$sub[fid].htm\">[ɾ]</a> <a href=\"".XIUNO_HOST_ADMIN."forum-moderator-$sub[fid].htm\" onclick=\"ajaxmenu(this.href, 1)\">[ð]</a>".($sub['status'] ? '<span class="alert">[]</span>' : '').'</li>';
						}
					}
					$s3 = $s3 ? "<ul>$s3</ul>" : $s3;
					$s2 .= $s3.'</li>';
				}
			}
			$s2 = $s2 ? "<ul>$s2</ul>" : $s2;
			$s .= $s2.'</li>';
		}
		$s .= '</ul>';
		return $s;
	}

	public function get_forum_options($haveroot = FALSE, $fid=0) {
		$forumsdata = $this->base->cache('forumsdata');
		$groups = $forumsdata['grouplist'];
		$forums = $forumsdata['forumlist'];
		$subs = $forumsdata['subslist'];

		$s = $haveroot ? '<option value="0">̳</option>' : '';
		foreach((array)$groups as $group) {
			$checked = $fid == $group['fid'] ? ' selected' : '';
			$s .= "<option value=\"$group[fid]\"$checked>$group[name]</option>";
			$s2 = '';
			if(!empty($forums[$group['fid']])) {
				foreach((array)$forums[$group['fid']] as $forum) {
					$checked = $fid == $forum['fid'] ? ' selected' : '';
					$s2 .= "<option value=\"$forum[fid]\"$checked>$forum[name]</option>";
					if($forum['sub']) {
						$s3 = '';
						if(!empty($subs[$forum['fid']])) {
							foreach((array)$subs[$forum['fid']] as $sub) {
								$checked = $fid == $sub['fid'] ? ' selected' : '';
								$s3 .= "<option value=\"$sub[fid]\"$checked>$sub[name]</option>";
							}
						}
						$s2 .= $s3;
					}
				}
			}
			$s .= $s2;
		}
		return $s;
	}

	public function format_forumlist(&$forumlist) {
		foreach($forumlist as $k=>&$forum) {
			if($forum['status'] == 1 && $this->base->group['groupid'] != 1) {
				unset($forumlist[$k]);
			} else {
				$this->format_forum($forum);
			}
		}
	}
	
	public function format_forum(&$forum) {
		getvalue($forum['lasttime']);
		getvalue($forum['lastusername']);
		getvalue($forum['lastsubject']);
		getvalue($forum['lasttid']);
		$forum['lastpost'] && list($forum['lasttime'], $forum['lastusername'], $forum['lastsubject'], $forum['lasttid']) = $forum['lastpost'] ? explode("\t", $forum['lastpost']) : array();
		$forum['dblasttime'] = $forum['lasttime'];
		$forum['name'] = $this->base->replace_color($forum['name']);
		$forum['lasttime'] = $forum['lasttime'] ? $this->base->date($forum['lasttime']) : '';
		$forum['lastsubject'] = $this->base->xiuno_substr($forum['lastsubject'], 28);
		$forum['icon'] = ($forum['dblasttime'] - $this->base->time) > DAY || $this->get_visited('visitedfid', $forum['fid']) ? IMGURL.'forum.png' : IMGURL.'forum_red.png';
	}

	// ڽcreditpolicybbs_forum
	public function implodecreditpolicy($arr, $sep1=',', $sep2=' ') {
		$str = '';
		foreach($arr as $action=>$policy) {
			$str .= $action;
			$i = 0;
			for($i=1; $i<=4; $i++) {
				$str .= $sep2.(isset($policy[$i]) ? $policy[$i] : 0);
			}
			$str .= $sep1;
		}
		return substr($str, 0, -1);
	}

	// ڴbbs_forumȡcreditpolicy
	public function explodecreditpolicy($str, $sep1=',', $sep2=' ') {
		$data = array();
		if(trim($str) == '') {
			return array();
		}
		$row = explode($sep1, $str);
		foreach($row as $v) {
			$arr = explode($sep2, $v);
			array_pad($arr, 5, 0);
			$action = $arr[0];
			unset($arr[0]);
			$data[$action] = $arr;
		}
		return $data;
	}

	public function get_visited($name, $value) {
		return strpos(getgpc($name, 'C'), "D$value") !== FALSE;
	}

	// ŵͻ
	public function set_visited($name, $value) {
		if(!$this->get_visited($name, $value)) {
			empty($_COOKIE[$name]) && $_COOKIE[$name] = '';
			$_COOKIE[$name] .= "D$value";
			$this->base->setcookie($name, $_COOKIE[$name], HOUR);
		}
	}

	public function get_sublist($fid) {
		$sublist = $this->db->fetch_all("SELECT * FROM bbs_forum WHERE fup='$fid'");
		foreach($sublist as &$sub) {
			$this->format_forum($sub);
		}
		return $sublist;
	}

	//  ͨuid  group[type]
	public function is_moderator($forum, $groupid, $uid) {
		if($groupid == XIUNO_ADMINISTRATOR_GROUPID || ($groupid == XIUNO_SUPER_MODERATOR_GROUPID && !$forum['status']) || !empty($forum['moderator'][$uid])) {
			return TRUE;
		} else {
			return FALSE;
		}
	}

	public function set_forum_lastpost($fid, $sqladd='') {
		// ̳, 󷢱 // $this->postmodel->rebuild_forum_lastpost($fid);
		$lasttread = $this->db->fetch_first("SELECT * FROM bbs_thread WHERE fid='$fid' ORDER BY lastpost DESC LIMIT 1");
		$lasttread['subject'] = $this->base->xiuno_substr($lasttread['subject'], 68);
		$lastpost = addslashes("$lasttread[dateline]	$lasttread[username]	$lasttread[subject]	$lasttread[tid]");
		$this->db->query("UPDATE bbs_forum SET lastpost='$lastpost' $sqladd WHERE fid='$fid'");
	}

	//heyonddebug
	public function get_threadtype_list_by_fid($fid) {
		$threadtypelist = $this->db->fetch_all("SELECT * FROM bbs_threadtype WHERE fid='$fid' ORDER BY displayorder");
		$data = array();
		foreach($threadtypelist as $threadtype) {
			$data[$threadtype['typeid']] = $threadtype;
		}
		return $data;
	}

	/**
	 * ˵ѡ
	 *
	 * @param int $fid ̳id
	 * @param int $typeid ѡе typeid
	 * @param bool/int $forcetypeid Ƿǿ
	 * @return unknown
	 */
	//heyonddebug
	public function get_threadtype_select($fid, $typeid = 0, $forcetypeid = 0) {
		$forum = $this->base->cache('forum', $fid);
		$arr = $forum['threadtypes'];
		if($arr) {
			$select = '<select name="typeid" id="typeid">';
			!$forcetypeid && $select .= '<option value=""></option>';
			foreach($arr as $type) {
				$selected = $type['typeid'] == $typeid ? ' selected="selected"' : '';
				$select .= "<option value=\"$type[typeid]\"$selected>$type[name]</option>";
			}
			$select .= '</select>';
			return $select;
		}
		return '';
	}

	public function get_threadlist_by_tids($tids) {
		$data = array();
		foreach($tids as $tid) {
			$data[$tid] = $this->db->fetch_first("SELECT * FROM bbs_thread WHERE tid='$tid'");
		}
		return $data;
	}

	public function get_rank_forums() {
		return $this->db->fetch_all("SELECT * FROM bbs_forum WHERE rank=1;");
	}

	public function get_forums_by_sql($sql = ''){
		empty($sql) && $sql = "SELECT fid, fup, type, name, description, threads, posts, todayposts, status, displayorder, lastpost, cols FROM bbs_forum ORDER BY displayorder DESC, threads DESC";
		$forums = $this->db->fetch_all($sql, 'fid'); //
		$totalthread = $totalpost = $todayposts = 0;
		$grouplist = $forumlist = $sublist = array();
		foreach($forums as $forum) {
			$totalthread += $forum['threads'];
			$totalpost   += $forum['posts'];
			$todayposts  += $forum['todayposts'];
			
			// ɫ滻
			switch($forum['type']) {
				case 'group':
					$grouplist[$forum['fid']] = $forum;
					break;
				case 'forum':
					$forumlist[$forum['fup']][$forum['fid']] = $forum;
					break;
				case 'sub':
					$sublist[$forum['fup']][$forum['fid']] = $forum;
					break;
				default:
					break;
			}
		}
		return array(
			'grouplist'   => $grouplist,
			'forumlist'   => $forumlist,
			'sublist'     => $sublist,
			'totalthread' => $totalthread,
			'totalpost'   => $totalpost,
			'todayposts'  => $todayposts
		);
	}
	
	// ҳתʱĲ
	// list($returnfid, $returntypeid, $returnpage) = get_return_arg(); referer, ж·ȷת·ߡ
	function get_forum_referer_arg() {
		$referer = $_SERVER['HTTP_REFERER'];
		preg_match("/\/forum-index-(\d+)-?(\d*)-?(\d*)\.htm$/", trim($referer), $m);
		list($__, $returnfid, $returntypeid, $returnpage) = $m;
		return array($returnfid, $returntypeid, $returnpage);
	}
}
?>