<?php

define('model/imagemodel.php', 1);

class imagemodel {

	private $db;
	private $base;

	function __construct(&$base) {
		$this->base = $base;
		$this->db = $base->db;
	}
	
	private function arr_to_sql($arr) {
		$sqladd = '';
		foreach($arr as $k=>$v){
			$sqladd .= "$k='$v',";
		}
		$sqladd = substr($sqladd, -1);
		return $sqladd;
	}
	
	public function get_image_by_imageid($imageid) {
		return $this->db->fetch_first("SELECT * FROM www_image WHERE imageid='$imageid'");
	}
	
	public function get_album_by_albumid($albumid) {
		return $this->db->fetch_first("SELECT * FROM my_album WHERE albumid='$albumid'");
	}
	
	// XXXȫ
	public function get_albumlist_by_uid_page($uid, $page, $ppp) {
		$page = max(1, $page);
		$start = ($page - 1) * $ppp;
		$sqladd = $uid == 0 ? '1 ORDER BY albumid DESC' : "uid='$uid' ORDER BY lastupdate";
		$albumlist = $this->db->fetch_all("SELECT * FROM my_album WHERE $sqladd LIMIT $start, $ppp");
		foreach($albumlist as &$album) {
			$album['lastupdatedb'] = $album['lastupdate'];
			$album['lastupdate'] = $this->base->date($album['lastupdate']);
		}
		return $albumlist;
	}
	
	// ʵȡͼƬ
	public function get_friend_imagelist_by_uid_page($uid, $page, $ppp, $fuidarr, &$totalnum) {
		$imageids = array();
		if(XIUNO_MEMCACHE_ON) {
			$mckey = XIUNO_SITENAME.'friend_images'.$uid;
			$imageids = $this->db->memcache_get($mckey);
		}
		if($imageids !== FALSE) {
			$start = ($page - 1) * $ppp;
			foreach($fuidarr as $uid) {
				$imageids = array_merge($imageids, $this->base->recentmodel->get_recent('image', $uid));
			}
			XIUNO_MEMCACHE_ON && $this->db->memcache_set($mckey, $imageids, 86400);
		}
		
		$totalnum = count($imageids);
		if(!$imageids) {
			return array();
		}
		$start = ($page - 1) * $ppp;
		$imagearr = array_slice($imageids, $start, $ppp);
		
		$sqladd = '';
		foreach($imagearr as $imageid) {
			$sqladd .= "imageid='$imageid' OR ";
		}
		$sqladd = substr($sqladd, 0, -4);
		$sqladd && $imagelist = $this->db->fetch_all("/*cachelife=86400&mckey=md5()*/ SELECT * FROM www_image WHERE $sqladd", 'imageid');
		return $imagelist;
	}
	
	// һҪô˷ $album['images'] ΪͼƬ
	public function get_totalimage_by_albumid($albumid) {
		return $this->db->result_first("SELECT COUNT(*) FROM www_image WHERE albumid='$albumid'");
	}
	
	public function get_imagelist_by_albumid_page($albumid, $page, $ppp) {
		$start = ($page - 1) * $ppp;
		$imagelist = $this->db->fetch_all("SELECT * FROM www_image WHERE albumid='$albumid' ORDER BY imageid DESC LIMIT $start, $ppp");
		foreach($imagelist as &$image) {
			$image['datelinedb'] = $image['dateline'];
			$image['dateline'] = $this->base->date($image['dateline']);
		}
		return $imagelist;
	}

	// ͼƬһӶ
	/**
	`imageid` int(11) unsigned NOT NULL AUTO_INCREMENT,                            
	`albumid` int(10) unsigned NOT NULL DEFAULT '0',                               
	`uid` int(11) unsigned NOT NULL DEFAULT '0',                                   
	`tid` int(11) unsigned NOT NULL DEFAULT '0',                                   
	`filesize` mediumint(8) unsigned NOT NULL DEFAULT '0',                         
	`filename` char(82) COLLATE latin1_bin NOT NULL DEFAULT '',                    
	`dateline` int(10) unsigned NOT NULL DEFAULT '0',                              
	`havethumb` tinyint(1) unsigned NOT NULL DEFAULT '0',                          
	`comment` char(100) COLLATE latin1_bin NOT NULL DEFAULT '',                    
	`views` int(10) NOT NULL DEFAULT '0',                                          
	`replies` int(10) NOT NULL DEFAULT '0',                                        
	`width` smallint(5) unsigned NOT NULL DEFAULT '0',                             
	`height` smallint(5) unsigned NOT NULL DEFAULT '0',                            
	*/
	
	/*
	array(
		0 = >
		array(
			'filesize'=>
			'filename'=>
			'havethumb'=>
			'width'=>
			'height'=>
		)
	)
	$arrs Ϊ lib/upload.class.php صʽ
	*/
	public function add_image($albumid, $uid, $username, &$arrs) {
		$images = $size = 0;
		$time = $this->base->time;
		$imageids = array();
		foreach($arrs as &$arr) {
			$havethumb = empty($arr['thumbpath']) ? 0 : 1;
			$this->db->query("INSERT INTO www_image SET albumid='$albumid', uid='$uid', username='$username', dateline='$time', filename='$arr[fileurl]', havethumb='$havethumb'");
			$imageid = $this->db->insert_id();
			$arr['imageid'] = $imageid;
			$imageid && $images++;
			$size += $arr['filesize'];
			$imageids[] = $imageid;
		}
		if($images) {
			$album = $this->get_album_by_albumid($albumid);
			// ûͼƬøͼƬΪ
			if($album['images'] == 0 || !empty($arr['setcover'])) {
				$this->update_cover($albumid, $imageid);
			}
			$this->db->query("UPDATE my_album SET images=images+'$images', lastupdate='$time' WHERE albumid='$albumid'");
			$this->db->query("/*primarykey=uid*/ UPDATE www_userfield SET attachsum=attachsum+'$size' WHERE uid='$uid'");
		}
		return $imageids;
	}
	
	// ༭ͼƬĳֵ
	/*
	array(
		'filesize'=>
		'filename'=>
		'havethumb'=>
		'comment'=>
		'width'=>
		'height'=>
	)
	*/
	public function edit_image($imageid, $setcover, $comment) {
		$this->db->query("UPDATE www_image SET comment='$comment' WHERE imageid='$imageid'");
		if($setcover) {
			$image = $this->db->fetch_first("SELECT * FROM www_image WHERE imageid='$imageid'");
			$thumbfile = $this->get_thumb($image['filename']);
			$this->db->query("UPDATE my_album SET cover='$thumbfile', coverid='$imageid' WHERE albumid='$image[albumid]'");
		}
		return $this->db->affected_rows();
	}
	
	public function delete_image($imageid) {
		$image = $this->get_image_by_imageid($imageid);
		$this->db->query("DELETE FROM www_image WHERE imageid='$imageid'");
		
		$affectedrow = $this->db->affected_rows();
		if($affectedrow) {
			$this->db->query("UPDATE my_album SET images=images-'1' WHERE albumid='$image[albumid]'");
			$this->update_cover($image['albumid'], 0);
		}
		// ɾ
		$this->base->replymodel->delete_reply_by_moduleid('image', $imageid);
		
		// ɾͼƬͼ
		$orgfile = XIUNO_ROOT.$image['filename'];
		$thumbfile = $this->get_thumb(XIUNO_ROOT.$image['filename']);
		is_file($orgfile) && unlink($orgfile);
		is_file($thumbfile) && unlink($thumbfile);
		
		return $affectedrow;
	}
	
	// Ҫ upload.class.php һ£ xxx_thumb.jpg
	private function get_thumb($filename) {
		$lastdot = strrpos($filename, '.');
		return substr($filename, 0, $lastdot).'_thumb.'.substr($filename, $lastdot + 1, 5);
	}
	
	// ·
	public function update_cover($albmid, $imageid) {
		if(empty($imageid)) {
			$cover = $this->db->fetch_first("SELECT imageid, filename FROM www_image WHERE albumid='$albmid' ORDER BY imageid DESC LIMIT 1");
		} else {
			$cover = $this->db->fetch_first("SELECT imageid, filename FROM www_image WHERE imageid='$imageid'");
		}
		if($cover) {
			$this->db->query("UPDATE my_album SET cover='$cover[filename]', coverid='$cover[imageid]' WHERE albumid='$albmid'");
		} else {
			$this->db->query("UPDATE my_album SET cover='', coverid='0' WHERE albumid='$albmid'");
		}
	}
	
	/***
	CREATE TABLE `my_album` (                                                       
            `albumid` int(10) unsigned NOT NULL AUTO_INCREMENT,                           
            `uid` int(11) unsigned NOT NULL DEFAULT '0',                                  
            `username` char(16) COLLATE latin1_bin NOT NULL DEFAULT '',                   
            `albumname` char(32) COLLATE latin1_bin NOT NULL,                             
            `images` int(10) unsigned NOT NULL DEFAULT '0',                               
            `lastupdate` int(10) unsigned NOT NULL DEFAULT '0',                           
            `isprivate` tinyint(1) unsigned NOT NULL DEFAULT '0',                         
            `cover` char(78) COLLATE latin1_bin NOT NULL,                                 
            `coverid` int(10) NOT NULL DEFAULT '0',                                       
            `password` char(32) COLLATE latin1_bin NOT NULL DEFAULT '',                   
            PRIMARY KEY (`albumid`),                                                      
            KEY `uidlastupdate` (`uid`,`lastupdate`)                                      
          ) ENGINE=MyISAM AUTO_INCREMENT=28577 DEFAULT CHARSET=latin1 COLLATE=latin1_bin  
        */
	public function add_album($uid, $username, $albumname, $isprivate, $password) {
		$this->db->query("INSERT INTO my_album SET uid='$uid', username='$username', cover='', albumname='$albumname', isprivate='$isprivate', password='$password'");
		$insertid = $this->db->insert_id();
		$this->base->usermodel->update_user($uid, "albums=albums+1");
		return $insertid;
	}
	
	/**
		array(
			'albumname'=>'',
			'isprivate'=>1,
			'password'=>'123456',
		)
	*/
	public function edit_album($albumid, $albumname, $isprivate, $password) {
		$this->db->query("UPDATE my_album SET albumname='$albumname', isprivate='$isprivate', password='$password' WHERE albumid='$albumid'");
		return $this->db->affected_rows();
	}
	
	// жǷΪĬ
	public function delete_album($albumid, $deleteimage = FALSE, $defaultalbumid = 0) {
		$album = $this->get_album_by_albumid($albumid);
		$this->db->query("DELETE FROM my_album WHERE albumid='$albumid'");
		// ǷɾµͼƬ
		if($deleteimage) {
			$arr = $this->db->fetch_all("SELECT * FROM www_image WHERE albumid='$albumid'");
			foreach($arr as $v) {
				unlink(XIUNO_ROOT.$arr['filename']);
			}
			$this->db->query("DELETE FROM www_image WHERE albmid='$albumid'");
		} else {
			$this->db->query("UPDATE www_image SET albumid='$defaultalbumid' WHERE albumid='$albumid'");
			$this->db->query("UPDATE my_album SET images=images+'$album[images]' WHERE albumid='$defaultalbumid'");
		}
		return 1;
		return $this->db->affected_rows();
	}
	
	// ͼƬĿ¼洢һһĿ¼
	/**
	Array
	(
	    [0] => Array
	        (
	            [fileurl] => data/attach//2010/0414/04_0_1252474436_0_1271316532.jpg
	            [filepath] => D:/www/xiuno2.0/data/attach//2010/0414/04_0_1252474436_0_1271316532.jpg
	            [filesize] => 295697
	            [type] => image
	            [orgfilename] => 04_0_1252474436.jpg
	            [thumburl] => data/attach//2010/0414/04_0_1252474436_0_1271316532_thumb.jpg
	            [thumbpath] => D:/www/xiuno2.0/data/attach//2010/0414/04_0_1252474436_0_1271316532_thumb.jpg
	            [thumbsize] => 6081
	            [width] => 500
	            [height] => 751
	        )
	*/
	public function upload_image() {
		if(!empty($_FILES)) {
			include_once XIUNO_ROOT.'lib/upload.class.php';
			$u = new Upload();
			$u->set_allowext($this->base->setting['allowext']);
			$u->set_dir(XIUNO_ATTACH_DIR.'album', XIUNO_ATTACH_URL.'album');
			$u->set_save_type('DATE');
			$u->set_width_height(800, 1600);
			$u->set_thumb(100, 100, 'gif');
			$u->set_watermark(XIUNO_WATER_FILE);
			return $u->execute();
		} else {
			return array();
		}
	}
	
	public function get_next_imageid($albumid, $imageid, $direction = '>') {
		return $this->db->result_first("SELECT imageid FROM www_image WHERE albumid='$albumid' AND imageid$direction'$imageid' ORDER BY imageid DESC LIMIT 1");
	}
}
?>