<?php

define('model/medalmodel.php', 1);

class medalmodel {

	private $db;
	private $base;
	private $medal;
	private $int2medal;

	function __construct(&$base) {
		$this->base = $base;
		$this->db = $base->db;
		$this->medal = $this->base->cache('medals');
		$this->init_medal2int();
	}

	public function get_medal_by_medalid($medalid) {
		$data = $this->medal[$medalid];
		if($data['expiration']) {
			$data['expiration'] = $this->base->date($data['expiration'], 'Y-m-d');
		} else {
			$data['expiration'] = '';
		}
		return $data;
	}

	public function get_medal_list_by_uid($uid) {
		$medals = $this->get_usermedal_by_uid($uid);
		$tmp_medals = $this->medal;
		$arr_medal = array();
		if(!empty($medals)) {
			foreach($medals as $medal) {
				$tmp_medal = $tmp_medals[$medal['medalid']];
				if($tmp_medal['expiration'] == 0 || $tmp_medal['expiration'] > $this->base->time) {
					$arr_medal[] = $tmp_medal;
				}
			}
		}
		return $arr_medal;
	}

	public function get_medal_list_by_int($int){
		if($int == 0) return array();
		$arr = str_split(strrev(decbin($int)));
		$data = array();
		foreach($arr as $k=>$v) {
			if(!$v) {
				continue;
			}
			$data[] = $this->medal[$this->int2medal[$k]];
		}
		return $data;
	}


	public function get_medals() {
		return $this->medal;
	}

	// TODO дѫµuser medallistֶ
	public function delete_medal($medalid) {
		return $this->db->query("DELETE FROM bbs_medal WHERE medalid='$medalid';");
	}

	/**
	 * ѫ
	 * @param int $medalid
	 * @param array $medal	array('medalname'=>'angel', 'expiration'=>'123456789')
	 * @return boolean
	 */
	public function update_medal($medalid, $medal) {
		if(!empty($medal) && is_array($medal)) {
			$str = '';
			foreach($medal as $k=>$v) {
				if($str) {
					$str .= ',';
				}
				$str .= "$k='$v'";
			}
			return $this->db->query("UPDATE bbs_medal SET $str WHERE medalid='$medalid';");
		}
		return FALSE;
	}

	public function insert_medal($medalname, $expiration) {
		if(count($this->medal) >= 32) {
			$this->base->message('ѫܳ32, ݲʹõѫ');
		}
		$this->db->query("INSERT INTO bbs_medal (medalname,expiration) VALUES ('$medalname','$expiration');");
		$this->init_medal2int(true);
		return $this->db->insert_id();
	}

	public function insert_usermedal($uid, $medalid) {
		$result = $this->db->query("INSERT INTO www_usermedal (uid,medalid) VALUES ('$uid','$medalid');");
		$int = $this->format_medalint_by_uid($uid);
		$this->base->usermodel->update_user($uid, "medallist='$int'");
		return $result;
	}

	// ¸ʽĳû www_user  medallist ֶ. ûѫ»ջѫʱ
	public function format_medalint_by_uid($uid) {
		$medal2int = array_flip($this->int2medal);
		$data = $this->db->fetch_all("SELECT medalid FROM www_usermedal WHERE uid='$uid'");
		$int = 0;
		foreach($data as $row) {
			$int += 1 << $medal2int[$row['medalid']];
		}
		return $int;
	}

	public function delete_usermedal($id, $uid) {
		$result = $this->db->query("DELETE FROM www_usermedal WHERE id='$id';");
		$int = $this->format_medalint_by_uid($uid);
		$this->db->query("/*primarykey=uid*/ UPDATE www_user SET medallist='$int' WHERE uid='$uid'");
		return $result;
	}

	public function get_usermedal_by_uid($uid) {
		return $this->db->fetch_all("SELECT * FROM www_usermedal WHERE uid='$uid';");
	}

	public function get_usermedal_by_medalid($medalid) {
		return $this->db->fetch_all("SELECT * FROM www_usermedal WHERE medalid='$medalid';");
	}

	public function is_usermedal_exists($uid, $medalid) {
		return $this->db->fetch_first("SELECT * FROM www_usermedal WHERE uid='$uid' AND medalid='$medalid';");
	}

	public function get_has_medal_users() {
		return $this->db->fetch_all("SELECT DISTINCT uid FROM www_usermedal");
	}

	public function get_medals_num_by_uid($uid) {
		return $this->db->result_first("SELECT COUNT(*) FROM www_usermedal WHERE uid='$uid';");
	}

	public function get_usermedal_by_id($id) {
		return $this->db->fetch_first("SELECT * FROM www_usermedal WHERE id='$id';");
	}

	private function get_not_format_medal_by_id($medalid) {
		return $this->db->fetch_first("SELECT * FROM bbs_medal WHERE medalid='$medalid';");
	}

	private function init_medal2int($force = 0) {
		$file = XIUNO_ROOT.'data/www/medal.php';
		if($force || !@include $file) {
			$int2medal = array_keys($this->db->fetch_all("SELECT medalid FROM bbs_medal", 'medalid'));
			if($fp = fopen($file, 'wb')) {
				flock($fp, LOCK_EX);
				fwrite($fp, "<?php\r\n".'$int2medal = '.var_export($int2medal, 1).";\r\n?>");
				fclose($fp);
			}
		}
		$this->int2medal = $int2medal;
	}
}
?>