<?php

define('model/replymodel.php', 1);

/**
CREATE TABLE `my_imagereply` (                                                
 `replyid` int(10) unsigned NOT NULL AUTO_INCREMENT,                         
 `imageid` int(10) unsigned NOT NULL DEFAULT '0',                            
 `dateline` int(10) unsigned NOT NULL DEFAULT '0',                           
 `uid` int(11) unsigned NOT NULL DEFAULT '0',                                
 `username` char(16) COLLATE latin1_bin NOT NULL DEFAULT '',                 
 `message` text COLLATE latin1_bin NOT NULL,                                 
 PRIMARY KEY (`replyid`),                                                    
 KEY `imageid` (`imageid`),                                                  
 KEY `imagereply` (`imageid`,`replyid`)                                      
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_bin  
*/

class replymodel {

	private $db;
	private $base;

	function __construct(&$base) {
		$this->base = $base;
		$this->db = $base->db;
	}

	// ӻظ
	public function add_reply($modulename, $moduleid, $message, $uid, $username, $moduleuid) {
		$dateline = $this->base->time;
		list($replytable, $moduletable, $modulekey) = $this->get_tablename_by_module($modulename);
		$this->db->query("INSERT INTO $replytable SET {$modulename}id='$moduleid', dateline='$dateline', uid='$uid', username='$username', message='$message'");
		$replyid = $this->db->insert_id();
		if($replyid) {
			//  memcache 
			$sqladd = $modulename == 'user' ? '/*primarykey=uid*/ ' : '';
			$this->db->query("{$sqladd}UPDATE $moduletable SET replies=replies+'1' WHERE $modulekey='$moduleid'");
			
			// ˴Ϊ˷㣬ƻ˲
			if($uid != $moduleuid) {
				if($modulename == 'image') {
					$filename = $this->base->get_thumb($this->db->result_first("SELECT filename FROM www_image WHERE imageid='$moduleid'"));
					$this->base->noticemodel->add_notice($this->base->user['uid'], $moduleuid, $this->base->user['username'], $username, array('imageid'=>$moduleid, 'filename'=>$filename), 'imagereply');
				} elseif($modulename == 'blog') {
					$subject = $this->db->result_first("SELECT subject FROM my_blog WHERE blogid='$moduleid'");
					$this->base->noticemodel->add_notice($this->base->user['uid'], $moduleuid, $this->base->user['username'], $username, array('blogid'=>$moduleid, 'subject'=>$subject), 'blogreply');
				} elseif($modulename == 'user') {
					$subject = $this->base->user['username'].'Ŀռԣ'.$this->base->xiuno_substr($message, 10);
					$this->base->noticemodel->add_notice($this->base->user['uid'], $moduleuid, $this->base->user['username'], $username, $subject, 'normal');
				}
			}
		}
		return $replyid;
	}
	
	// ͳƻظҳ
	public function get_totalnum_by_moduleid($modulename, $moduleid) {
		// ӸȡݣЧ
		list($replytable, $moduletable, $modulekey) = $this->get_tablename_by_module($modulename);
		return $this->db->result_first("SELECT replies FROM $moduletable WHERE $modulekey='$moduleid'");
	}

	// ҳȡݣװ control 
	public function get_replylist_by_page($modulename, $moduleid, $replies, $page) {
		list($replytable, $moduletable, $modulekey) = $this->get_tablename_by_module($modulename);
		$module = $this->get_module_by_moduleid($modulename, $moduleid);
		
		$modulereplynum	 = $replies;
		$modulemultipage = $this->base->page($modulereplynum, XIUNO_PPP, $page, XIUNO_HOST_MY."reply-ajaxls-$modulename-$moduleid.htm?totalnum=$modulereplynum", 0, $modulename.'replypagebody');
		$modulereplylist = $this->_get_replylist_by_page($modulename, $moduleid, $page, XIUNO_PPP, $modulereplynum);
		
		// ʽ
		foreach($modulereplylist as &$modulereply) {
			$modulereply['dateline'] = $this->base->date($modulereply['dateline']);
			$modulereply['avatar_small'] = $this->base->get_avatar($modulereply['uid'], 'small');
		}
		$this->base->view->assign_value('modulename', $modulename);
		$this->base->view->assign_value('moduleid', $module[$modulekey]);
		$this->base->view->assign_value('modulereplylist', $modulereplylist);
		$this->base->view->assign_value('modulereplynum', $modulereplynum);
		$this->base->view->assign_value('modulemultipage', $modulemultipage);
	}
		
	// ҳȡ
	public function _get_replylist_by_page($modulename, $moduleid, $page, $ppp, $totalnum) {
		$start = ($page - 1) * $ppp;
		list($replytable, $moduletable, $modulekey) = $this->get_tablename_by_module($modulename);
		$replylist = $this->db->fetch_all("SELECT * FROM $replytable WHERE {$modulename}id='$moduleid' ORDER BY replyid LIMIT $start, $ppp");
		return $replylist;
	}

	// ȡһظ
	public function get_reply_by_replyid($modulename, $replyid) {
		list($replytable, $moduletable, $modulekey) = $this->get_tablename_by_module($modulename);
		$reply = $this->db->fetch_first("SELECT * FROM $replytable WHERE replyid='$replyid'");
		return $reply;
	}
	
	// ɾ
	public function delete_reply_by_moduleid($modulename, $moduleid) {
		list($replytable, $moduletable, $modulekey) = $this->get_tablename_by_module($modulename);
		$this->db->query("DELETE FROM $replytable WHERE {$modulename}id='$moduleid'");
		$affectedrow = $this->db->affected_rows();
		if($affectedrow) {
			//  memcache 
			$sqladd = $modulename == 'user' ? '/*primarykey=uid*/ ' : '';
			$this->db->query("{$sqladd}UPDATE $moduletable SET replies=replies-'$affectedrow' WHERE $modulekey='$moduleid'");
		}
		return $affectedrow;
	}	
	
	// ɾһ
	public function delete_reply_by_replyid($modulename, $moduleid, $replyid) {
		list($replytable, $moduletable, $modulekey) = $this->get_tablename_by_module($modulename);
		$this->db->query("DELETE FROM $replytable WHERE replyid='$replyid'");
		
		$affectedrow = $this->db->affected_rows();
		if($affectedrow) {
			//  memcache 
			$sqladd = $modulename == 'user' ? '/*primarykey=uid*/ ' : '';
			$this->db->query("{$sqladd}UPDATE $moduletable SET replies=replies-'1' WHERE $modulekey='$moduleid'");
		}
		return $affectedrow;
	}
	
	// ʽظ
/*	public function format_reply(&$reply) {
		$reply['dateline'] = $this->base->date($reply['dateline']);
		$reply['avatar_small'] = $this->base->get_avatar($reply['uid'], 'small');
	}*/
	
	public function get_module_by_moduleid($modulename, $moduleid) {
		list($replytable, $moduletable, $modulekey) = $this->get_tablename_by_module($modulename);
		return $this->db->fetch_first("SELECT * FROM $moduletable WHERE $modulekey='$moduleid'");
	}
	
	
	//  replytable moduletable modulekey
	public function get_tablename_by_module($modulename) {
		if($modulename == 'image') {
			return array('www_imagereply', 'www_image', 'imageid');
		} elseif($modulename == 'blog') {
			return array('my_blogreply', 'my_blog', 'blogid');
		} elseif($modulename == 'user') {
			return array('www_userreply', 'www_user', 'uid');
		} else {
			//return array('my_blogreply', 'my_blog', 'blogid');
		}
	}
	
}
?>