<?php

define('model/tidcachemodel.php', 1);

class tidcachemodel {

	private $db;

	function __construct(&$base) {
		$this->base = $base;
		$this->db = $base->db;
	}

	public function init($fid, $level = 1) {
		if(!(XIUNO_BBS_TID_CACHE_1_ON && $level == 1 || XIUNO_BBS_TID_CACHE_2_ON && $level == 2)) {
			return false;
		}
		$filename = XIUNO_ROOT."data/cache/tidcache_{$level}_{$fid}.txt";
		touch($filename);
	}

	public function get_tid_list($fid, $page, $ppp) {
		// жҳ
		$level = $page > XIUNO_BBS_TID_CACHE_1_PAGE ? 2 : 1;
		if(!(XIUNO_BBS_TID_CACHE_1_ON && $level == 1 || XIUNO_BBS_TID_CACHE_2_ON && $level == 2)) {
			return false;
		}
		$filename = XIUNO_ROOT."data/cache/tidcache_{$level}_{$fid}.txt";

		$fp = fopen($filename, 'rb');
		if(!$fp) {
			return array();
		}
		fseek($fp, ($ppp * ($page - 1)) * 4);
		$data = fread($fp, $ppp * 4);
		return (array)unpack("L*", $data);

	}

	// ֻһ
	public function add_tid($fid, $tid) {
		if(!XIUNO_BBS_TID_CACHE_1_ON) {
			return false;
		}

		// ȡ
		$filename = XIUNO_ROOT."data/cache/tidcache_1_{$fid}.txt";
		$s = file_get_contents($filename);

		// תΪ
		$arr = (array)unpack("L*", $s);

		// ɾеԪ
		foreach($arr as $k=>$_tid) {
			if($tid == $_tid) {
				unset($arr[$k]);
				break;
			}
		}

		// Ԫ
		array_unshift($arr, $tid);

		// д뻺
		$this->write_to_tidcache($arr, $filename);

	}

	// ֻһ
	public function delete_tid($fid, $tid) {
		if(!XIUNO_BBS_TID_CACHE_1_ON) {
			return false;
		}
		// ȡ
		$filename = XIUNO_ROOT."data/cache/tidcache_1_{$fid}.txt";
		$s = file_get_contents($filename);

		// תΪ
		$arr = (array)unpack("L*", $s);

		// ɾеԪ
		foreach($arr as $k=>$_tid) {
			if($tid == $_tid) {
				unset($arr[$k]);
				break;
			}
		}

		// д뻺
		$this->write_to_tidcache($arr, $filename);
	}

	// ֻһ
	public function delete_tids($fid, $tids) {
		if(!XIUNO_BBS_TID_CACHE_1_ON) {
			return false;
		}
		// ȡ
		$filename = XIUNO_ROOT."data/cache/tidcache_1_{$fid}.txt";
		$s = file_get_contents($filename);

		// תΪ
		$arr = (array)unpack("L*", $s);

		// ɾеԪ
		foreach($arr as $k=>$tid) {
			if(in_array($tid, $tids)) {
				unset($arr[$k]);
			}
		}

		// д뻺
		$this->write_to_tidcache($arr, $filename);
	}

	public function rebuild($fid, $level = 1) {
		if(!(XIUNO_BBS_TID_CACHE_1_ON && $level == 1 || XIUNO_BBS_TID_CACHE_2_ON && $level == 2)) {
			return false;
		}
		$filename = XIUNO_ROOT."data/cache/tidcache_{$level}_{$fid}.txt";

		if($level == 1) {
			$limit = XIUNO_BBS_TID_CACHE_1_PAGE * XIUNO_TPP;
			$sqladd = "ORDER BY lastpost DESC LIMIT 0, $limit";
			$arr = $this->db->fetch_all("SELECT tid FROM bbs_thread WHERE fid='$fid' $sqladd", 'tid');
			$arr = array_keys($arr);
			// д뻺
			$this->write_to_tidcache($arr, $filename);
		} else {
			$num = $this->db->result_first("SELECT COUNT(*) FROM bbs_thread WHERE fid='$fid'");
			if($num < 500000) {
				$arr = $this->db->fetch_all("SELECT tid FROM bbs_thread WHERE fid='$fid' ORDER BY lastpost", 'tid');
				$arr = array_keys($arr);
				// д뻺
				$this->write_to_tidcache($arr, $filename);
			} else {
				// ܴУֹʱ
				if(file_exists(XIUNO_PHP_CGI_PATH)) {
					pclose(popen(XIUNO_PHP_CGI_PATH.' '.XIUNO_ROOT.'tool/tidcache_rebuild.php '.$fid.' '.$level, 'r'));
				} else {
					$this->logmodel->writeweblog('PHP_CGI_PATH: '.XIUNO_PHP_CGI_PATH.' ', '⻺ʱʧ');
				}
			}
		}
	}

	public function rebuildall($level) {
		if(!(XIUNO_BBS_TID_CACHE_1_ON && $level == 1 || XIUNO_BBS_TID_CACHE_2_ON && $level == 2)) {
			return false;
		}
		$fids = $this->db->fetch_all("SELECT fid FROM bbs_forum WHERE type<>'group'");
		foreach($fids as $data) {
			$fid = $data['fid'];
			$filename ="tidcache_{$level}_{$fid}.txt";
			$this->rebuild($fid, $level);
		}
	}

	// ɾ̳ʱ
	public function delete_cache($fid) {
		$file1 = XIUNO_ROOT."data/cache/tidcache_1_{$fid}.txt";
		$file2 = XIUNO_ROOT."data/cache/tidcache_2_{$fid}.txt";
		is_file($file1) && unlink($file1);
		is_file($file2) && unlink($file2);
	}

	// д뻺
	private function write_to_tidcache($arr, $filename) {
		$tids = '';
		foreach($arr as $k=>$_tid) {
			$tids .= pack("L", $_tid);
		}
		file_put_contents($filename, $tids);
	}
}
?>